' IsCharSet.VBS V1.01 (C) yoshioka.teruo@nifty.com 2005-10-24
' IsCharSet.VBS examines whether character is in character set.
' Usage: Start IsCharSet.VBS [files...]
' Usage: CScript.EXE //NoLogo IsCharSet.VBS [files...] >result

Option Explicit
Dim fso:Set fso=CreateObject("Scripting.FileSystemObject")
Dim Rows:Rows=Array()
Dim arg
Dim Text

SetLocale "en-us"

For Each arg In WScript.Arguments
  Call IsCharSet(fso.OpenTextFile(arg,,,-2).ReadAll())
Next
If WScript.Arguments.Count()=0 Then
  Text=GetCLipByMsForms()
  If IsNull(Text) Then Text=GetCLipByMsIE()
  arg="Clipboard"
  Call IsCharSet(Text)
End If

WScript.Quit

Sub IsCharSet(ByVal Lines)
Dim Line
Dim j
Dim k
Dim char
Dim nFound:nFound=0

Lines=Split(Lines,vbCrLf)
For j=1 To UBound(Lines)+1
  Line=Lines(j-1)
  For k=1 To Len(Line)
    char=Mid(Line,k,1)
    If char<>Chr(Asc(char)) Then
      nFound=nFound+1
      Echo Join(Array("Line",j,"Column",k,"Char",char,"Code",Hex(AscW(char))),vbTab)
    End If
  Next
Next
Echo arg&" : "&nFound
If UBound(Rows)>-1 Then
  MsgBox Join(Rows,vbLf),,arg
  Rows=Array()
End If
End Sub

Sub Echo(str)
On Error Resume Next
WScript.StdOut.WriteLine str
If Err=0 Then Exit Sub
If UBound(Rows)=20 Then
  If vbCancel=MsgBox(Join(Rows,vbLf),vbOkCancel,arg) Then WScript.Quit
  Rows=Array()
End If
ReDim Preserve Rows(UBound(Rows)+1)
Rows(UBound(Rows))=str
End Sub


Function GetCLipByMsIE()
Const OLECMDID_PASTE = 13
Const OLECMDEXECOPT_DODEFAULT = 0
Dim ie
Set ie=CreateObject("InternetExplorer.Application")
'ie.Visible=true
ie.Navigate "about:blank"
Do While ie.Busy Or ie.ReadyState<>4
  WScript.Sleep 100
Loop
ie.Document.write "<html><body><textarea id=txt></textarea></body></html>"
ie.Document.all.txt.focus
Call ie.ExecWB(OLECMDID_PASTE,OLECMDEXECOPT_DODEFAULT)
GetCLipByMsIE=ie.Document.all.txt.value
ie.Quit 
End Function

Function GetCLipByMsForms()
Dim uf
Dim tb
Dim Text
On Error Resume Next
Set uf=CreateObject("Forms.Form.1")
On Error GoTo 0
If IsEmpty(uf) Then
  GetCLipByMsForms=Null
  Exit Function
End If
Set tb=uf.Controls.Add("Forms.TextBox.1").Object
tb.MultiLine=True
If tb.CanPaste Then
  tb.Paste
End If
Text=tb.Text
Set tb=Nothing
Set uf=Nothing
GetCLipByMsForms=Text
End Function
